#!/usr/bin/env python
import random as rnd

rnd.seed(431)

def write_test(n, test_str):
    filename = "{:0>2}".format(n)
    filename += ".in"
    f = open(filename, "w")
    f.write(test_str)

class TestGen:
    def __init__(self, first_testno):
        self.testno = first_testno

    def next_test(self, teststr):
        write_test(self.testno, teststr)
        self.testno += 1

def fmt(n, t, m, x, a, v):
    inputs = [[n, t, m, x], a, v]
    return "\n".join(map(lambda x: " ".join(map(str, x)), inputs))

def rand(n, t):
    m = rnd.randint(1, 10**5 // t)
    x = rnd.randint(1, 10**5)
    a = [rnd.randint(1, 10**5) for i in range(n)]
    v = [rnd.randint(1, 10**5) for i in range(n)]
    return fmt(n, t, m, x, a, v)

gen = TestGen(13)
gen.next_test(rand(100, 10))
gen.next_test(rand(100, 100))
gen.next_test(rand(1000, 100))
gen.next_test(rand(1000, 1000))
gen.next_test(rand(1000, 1000))
gen.next_test(rand(1000, 1000))
gen.next_test(rand(999, 10000))
gen.next_test(rand(999, 10000))
gen.next_test(rand(999, 10000))

gen.next_test(rand(10**5, 10))
gen.next_test(rand(10**5, 100))
gen.next_test(rand(10**5, 100))
gen.next_test(rand(10**5, 1000))
gen.next_test(rand(10**5, 1000))
gen.next_test(rand(10**5, 1000))
gen.next_test(rand(10**5, 10000))
gen.next_test(rand(10**5, 10000))
gen.next_test(rand(10**5, 10000))

gen.next_test(rand(10**4, 10))
gen.next_test(rand(10**4, 10))
gen.next_test(rand(10**4, 10))
gen.next_test(rand(10**4, 10))
gen.next_test(rand(10**4, 10))
gen.next_test(rand(10**4, 10))

gen.next_test(rand(rnd.randint(1, 10000), rnd.randint(10, 1000)))
gen.next_test(rand(rnd.randint(1, 10000), rnd.randint(10, 1000)))
gen.next_test(rand(rnd.randint(1, 10000), rnd.randint(10, 1000)))
gen.next_test(rand(rnd.randint(1, 10000), rnd.randint(10, 1000)))

