#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

typedef long long i64;

i64 ceil(i64 a, i64 b) {
    return (a + b - 1) / b;
}

int n, t, m, x;
vector<i64> a;
vector<i64> v;

bool is_feasible(i64 h) {
    vector<int> q(t);

    i64 sum = 0;
    for (int i = 0; i < n; i++) {
        sum += max(0ll, ceil(a[i] + v[i] * t - h, x));
    }

    if (sum > t * m) {
        return false;
    }

    for (int i = 0; i < n; i++) {
        i64 th = a[i] + v[i] * t;
        i64 d = th - h;
        if (d <= 0) {
            continue;
        }
// for (i64 cut = (d % x == 0 ? x : d % x); cut <= d; cut += x) {
        for (i64 cut = x; cut <= d + x - 1; cut += x) {
            i64 day = max<i64>(ceil(cut - a[i], v[i]), 0);
            if (day >= q.size()) {
                return false;
            }

            q[day]++;
        }
    }

    i64 events = 0;
    for (int i = 0; i < t; i++) {
        events += q[i];
        events -= m;
        events = max<i64>(0, events);
    }

    return events == 0;
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    cin >> n >> t >> m >> x;
    a.resize(n);
    v.resize(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }

    i64 l = 0;
    i64 r = 2e10;

    while (r - l > 1) {
        i64 mid = (r + l) / 2;

        if (is_feasible(mid)) {
            r = mid;
        } else {
            l = mid;
        }
    }

    cout << r << endl;
}